package com.zhentao.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.zhentao.domain.Goods;
import com.zhentao.dto.GoodsDto;
import com.zhentao.service.GoodsService;
import com.zhentao.mapper.GoodsMapper;
import com.zhentao.util.SnowflakeIdGenerator;
import com.zhentao.vo.ResultVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.DigestUtils;

import java.nio.charset.StandardCharsets;
import java.util.Map;
import java.util.TreeMap;

/**
* @author 31810
* @description 针对表【goods】的数据库操作Service实现
* @createDate 2025-05-16 09:17:25
*/
@Service
public class GoodsServiceImpl extends ServiceImpl<GoodsMapper, Goods>
    implements GoodsService{
    @Autowired
    private GoodsMapper goodsMapper;
    private static final String APP_SECRET="123";
    @Override
    public ResultVo addGoods(GoodsDto goodsDto) {
        Goods goods=new Goods();
        if(goodsDto.getGoodsName()!=null){
            goods.setGoodsName(goodsDto.getGoodsName());
        }
        if(goodsDto.getGoodsImg()!=null){
            goods.setGoodsImg(goodsDto.getGoodsImg().getOriginalFilename());
        }
        if(goodsDto.getContent()!=null){
            goods.setContent(goodsDto.getContent());
        }
        goods.setId(SnowflakeIdGenerator.getSnowId());
        goodsMapper.insert(goods);
        return ResultVo.OK();
    }

    @Override
    public ResultVo findGoods(GoodsDto goodsDto, String reqId, Long reqTime, String appId) {
        Map<String,Object>map=new TreeMap<>();
        map.put("reqId",reqId);
        map.put("goodsId",goodsDto.getGoodsId());
        map.put("reqTime",reqTime);
        map.put("appId",appId);
        StringBuilder stringBuilder=new StringBuilder();
        for (Map.Entry<String,Object> m:map.entrySet()) {
            stringBuilder.append(m.getKey()).append("=").append(m.getValue()).append("&");
        }
        stringBuilder.append("key").append(APP_SECRET);
        String md5Sign= DigestUtils.md5DigestAsHex(stringBuilder.toString().getBytes(StandardCharsets.UTF_8));
        if(md5Sign.equals(goodsDto.getSign())){
            Long goodsId = goodsDto.getGoodsId();
            Goods goods = goodsMapper.selectById(goodsId);
            return ResultVo.OK(goods.getGoodsName());
        }
        return new ResultVo(1002,"验签失败",null);
    }
}




