package com.zhentao.tast;

import com.zhentao.domain.KafkaSend;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.kafka.annotation.KafkaHandler;
import org.springframework.kafka.annotation.KafkaListener;
import org.springframework.kafka.core.KafkaTemplate;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.util.UUID;

@Component
public class KafkaTask {
    @Autowired
    private KafkaTemplate<String,String>kafkaTemplate;
    @Scheduled(fixedRate = 60000)
    public void sendMessage(){
        KafkaSend kafkaSend=new KafkaSend();
        kafkaSend.setContent("考试消费信息");
        kafkaSend.setMsgId(UUID.randomUUID().toString().replace("-",""));
        kafkaSend.setMsgtype("type");
        kafkaTemplate.send("test",kafkaSend.getContent());
    }

    @KafkaListener(topics = "test")
    public void listener(String message){
        System.out.println("kafka消费了,信息是"+message);
    }
}
